indexing

	description: "Test URI parsing."

	author: "Berend de Boer"
	date: "$Date: 2004/12/18 $"
	revision: "$Revision: #2 $"


deferred class

	TEST_URI_PARSER

inherit

	TS_TEST_CASE

feature -- Tests

	test_parsing is
		local
			uri: EPX_URI
		do
			create uri.make ("http://www.ics.uci.edu/pub/ietf/uri/#Related")
			check_uri (uri, "http", "www.ics.uci.edu", "/pub/ietf/uri/", Void, "Related")

			create uri.make ("http://www.ics.uci.edu/cgi-bin/test?id=1")
			check_uri (uri, "http", "www.ics.uci.edu", "/cgi-bin/test", "id=1", Void)

			create uri.make ("http:/cgi-bin/test?id=1")
			check_uri (uri, "http", Void, "/cgi-bin/test", "id=1", Void)

			create uri.make ("http:/cgi-bin/test")
			check_uri (uri, "http", Void, "/cgi-bin/test", Void, Void)

			create uri.make ("various.html")
			check_uri (uri, Void, Void, "various.html", Void, Void)

			create uri.make ("various.html#index")
			check_uri (uri, Void, Void, "various.html", Void, "index")

			create uri.make ("http://ad.doubleclick.net/adj/reuters.com.dart/news/usnews/article;type=interstitial;articleID=5901464;sz=1x1;dcopt=ist;ord=498688466?")
			check_uri (uri, "http", "ad.doubleclick.net", "/adj/reuters.com.dart/news/usnews/article;type=interstitial;articleID=5901464;sz=1x1;dcopt=ist;ord=498688466", Void, Void)
		end

	test_abnormal_cases is
		local
			uri: EPX_URI
		do
			create uri.make ("//")
			check_uri (uri, Void, Void, Void, Void, Void)
		end


feature {NONE} -- Implementation

	check_uri (uri: EPX_URI; scheme, authority, path, query, fragment: STRING) is
		do
			do_check ("scheme", uri.scheme, scheme)
			do_check ("authority", uri.authority, authority)
			do_check ("path", uri.path, path)
			do_check ("query", uri.query, query)
			do_check ("fragment", uri.fragment, fragment)
		end

	do_check (what, s1, s2: STRING) is
		do
			assert_equal (what, s1, s2)
		end

end
