indexing

	description: "Test Posix mkfifo and forking."

	author: "Berend de Boer"
	date: "$Date: 2005/03/03 $"
	revision: "$Revision: #5 $"

deferred class

	TEST_P_FORK


inherit

	TS_TEST_CASE
		rename
			exceptions as test_exceptions
		end

	POSIX_CURRENT_PROCESS
		export
			{NONE} all
		end

	POSIX_FILE_SYSTEM
		export
			{NONE} all
		end

	POSIX_SYSTEM
		export
			{NONE} all
		end


feature -- Tests

	test_fork is
		do
			if system_name.substring_index ("CYGWIN", 1) = 0 then
				do_test_fork
			else
				print ("fifo not supported on Cygwin, can't test forking.%N")
			end
		end


feature {NONE} -- Implementation

	do_test_fork is
		local
			reader: POSIX_TEXT_FILE
			stop_sign: BOOLEAN
			child: FORK_CHILD
		do
			print ("My pid: ")
			print (pid)
			print ("%N")

			unlink ("berend.tmp")
			print ("Make a fifo.%N")
			create_fifo ("berend.tmp", S_IRUSR + S_IWUSR)
			create child
			print ("Fork object.%N")
			fork (child)
			print ("child pid: ")
			print (child.pid)
			print ("%N")

			-- we will now block until file is opened for writing.
			create reader.open_read ("berend.tmp")
			from
				stop_sign := False
			until
				stop_sign
			loop
				reader.read_line
				print (reader.last_string)
				stop_sign := equal (reader.last_string, "stop")
			end
			reader.close

			-- now wait for the writer to terminate
			child.wait_for (True)

			unlink ("berend.tmp")
		end

end
